//+------------------------------------------------------------------+
//|                                                       Benjam.mq4 |
//|                                                    Benjam Limjap |
//|                                                                  |
//+------------------------------------------------------------------+
#property copyright "Benjam Limjap"
#property link      ""
#property version   "4.00"
#property strict
#property indicator_chart_window

extern bool RSI_OnOff = true;
extern bool STOC_OnOff = true;
extern bool BOLI_OnOff = true;

extern int RSI_State = 0;
extern int STOC_State = 0;
extern int BOLI_State = 0;

extern string alert = "";//  =========================================
extern bool Alert_OnOff = true;
extern bool Alert_Sound = true;


   int RSI_SWITCH, STOC_SWITCH, BOLI_SWITCH;
   int RSI_ORD, STOC_ORD, BOLI_ORD;
   static datetime tmp;
   int TTF = Period();
   string timep,Sym = Symbol();
   int wait_TF = 0;
   bool firsttick;

//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int OnInit()
  {
   RSI_ORD=RSI_State;
   STOC_ORD=STOC_State;
   BOLI_ORD=BOLI_State;
   tmp =  Time[0];
   Comment("24O Alerting - "+Symbol()+" - "+DoubleToStr(Period(),0)+" TF");
//---
   return(INIT_SUCCEEDED);
  }
//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int OnCalculate (const int rates_total,
                 const int prev_calculated,
                 const datetime& time[],
                 const double& open[],
                 const double& high[],
                 const double& low[],
                 const double& close[],
                 const long& tick_volume[],
                 const long& volume[],
                 const int& spread[])
  {
  
//-------------------  EXPIRY ------------------
/*
datetime EXP = D'2014.09.01 00:00';
 if(TimeCurrent() < EXP)
{
*/
//-------------------  EXPIRY ------------------
  
  
  //---------------------------------------------------------------- 
   double RSI_Price = iRSI(NULL,0,14,0,0);
   double STOC_Price = iStochastic(NULL,0,5,3,3,0,0,0,0);
   double BOLI_Price_UP = iBands(NULL,0,20,2,0,0,1,0);
   double BOLI_Price_DOWN = iBands(NULL,0,20,2,0,0,2,0);
   
  //---------------------------------------------------------------- 
   if(RSI_Price > 70) {RSI_SWITCH = 1;}
   if(RSI_Price < 30) {RSI_SWITCH = -1;}
   if(STOC_Price > 80) {STOC_SWITCH = 1;}
   if(STOC_Price < 20) {STOC_SWITCH = -1;}
   if(BOLI_Price_UP <= Bid) {BOLI_SWITCH = 1;}
   if(BOLI_Price_DOWN >= Bid) {BOLI_SWITCH = -1;}
   
   if(RSI_SWITCH == 1 && RSI_Price < 70) {RSI_ORD = 1;}
   if(RSI_SWITCH == -1 && RSI_Price > 30) {RSI_ORD = -1;}
   if(STOC_SWITCH == 1 && STOC_Price < 80) {STOC_ORD = 1;}
   if(STOC_SWITCH == -1 && STOC_Price > 20) {STOC_ORD = -1;}
   if(BOLI_SWITCH == 1 && BOLI_Price_UP > Bid) {BOLI_ORD = 1;}
   if(BOLI_SWITCH == -1 && BOLI_Price_DOWN < Bid) {BOLI_ORD = -1;}
   
  //----------------------------------------------------------------  
    if(TTF != Period() || Sym!=Symbol())
   {
      Sym = Symbol();
      TTF = Period();
      Reset();
   }
  
  //----------------------------------------------------------------  
   if(firsttick == true)
   if( (wait_TF == 0) )
   if( (RSI_Price > 70) && (STOC_Price > 80) && (Bid > BOLI_Price_UP) )
   {
   
  //----------------------------------------------------------------       
   if(Alert_OnOff == true)   
   timep = TimeToStr(TimeCurrent(),TIME_DATE|TIME_MINUTES);
   
      Alert
      ("SELL " + Symbol() +" at "+DoubleToStr(Period(),0)+" min" "\n"
      "Currency Pair   -  " + Symbol() +"\n"
      "Position              -  Sell! "+"\n"
      "Time                   -  "+timep +"\n"
      "Price                   -  "+DoubleToStr(Bid,4)
      );
    
         if(Alert_Sound==true)
         {
           PlaySound("Alert.wav");
         } 
         
   //----------------------------------------------------------------          
      Reset();
      wait_TF = 1;
   }
   if(firsttick == true)
   if( (wait_TF == 0) )
   if( (RSI_Price < 30) && (STOC_Price < 20) && (Bid < BOLI_Price_DOWN) )
   {
      
  //----------------------------------------------------------------       
   if(Alert_OnOff == true) 
   {  
   timep = TimeToStr(TimeCurrent(),TIME_DATE|TIME_MINUTES);
   
      Alert
      ("BUY " + Symbol() +" at "+DoubleToStr(Period(),0)+" min" "\n"
      "Currency Pair   -  " + Symbol() +"\n"
      "Position              -  Buy! "+"\n"
      "Time                   -  "+timep +"\n"
      "Price                   -  "+DoubleToStr(Bid,4)
      );
    
         if(Alert_Sound==true)
         {
           PlaySound("Alert.wav");
         } 
   }
         
   //----------------------------------------------------------------          
      Reset();
      wait_TF = 1;
   }
  //----------------------------------------------------------------   

    firsttick = false;
    
    if (tmp!= Time[0])
   {
   tmp =  Time[0];
   wait_TF = 0;
   firsttick = true;
   
   }

   return(rates_total);
 
 
} 
//+---------------------------- End Of OnCalculate--------------------------------------+
void Reset()
{
   RSI_SWITCH=0;
   STOC_SWITCH=0;
   BOLI_SWITCH=0;
   
   RSI_ORD=0;
   STOC_ORD=0;
   BOLI_ORD=0;
}